unit MAIN;

interface

uses Windows, SysUtils, Classes, Forms, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, ShellAPI, Controls, MenuFileHistoryUnit1;

const
  DEFAULT_EXTENSION = 'lvl';
  DEFAULT_NAME = 'Untitled';
  APP_NAME = 'lvl Editor';
  PEN = 0;         //pen
  ERASE = 1;       //erasor
  SELECT = 2;      //marquee
  DROPPER = 3;     //eye dropper
  STAMPER = 4;     //stamper
  MAGNIFY = 5;     //maginifier
  FILL = 6;        //filler
  FLIPHORI = 7;    //flip horizontal
  FLIPVERT = 8;    //Flip vertical
  LINE = 9;        //Line
  POLYLINE = 10;   //connected line
  RECT = 11;       //rectangle/square
  RECTFILL = 12;   //filled
  CIRCLE = 13;     //ellipse/circle
  CIRCLEFILL = 14; //filled
  AREAFILL = 15;   //area fill tool

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ActionList1: TActionList;
    FileNew1: TAction;
    FileExit1: TAction;
    FileOpen1: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    tools: TToolBar;
    btnOpen: TToolButton;
    btnSave: TToolButton;
    btnSpace1: TToolButton;
    btnCut: TToolButton;
    btnCopy: TToolButton;
    btnPaste: TToolButton;
    btnNew: TToolButton;
    btnSpace2: TToolButton;
    ImageList1: TImageList;
    SendFeedback1: TMenuItem;
    SendFeedback2: TMenuItem;
    btnAbout: TToolButton;
    HelpAbout: TAction;
    N3: TMenuItem;
    echSupportFAQ1: TMenuItem;
    GuideandHelp1: TMenuItem;
    SaveDialog: TSaveDialog;
    FileClose1: TAction;
    FileSave1: TAction;
    FileSaveAs1: TAction;
    N1: TMenuItem;
    FileImport1: TAction;
    btnSpace3: TToolButton;
    ViewToolBar1: TAction;
    ViewStatusBar1: TAction;
    View1: TMenuItem;
    ViewMainToolbar1: TMenuItem;
    ViewStatus1: TMenuItem;
    FileRecent: TMenuItem;
    ViewTileWindow: TAction;
    ViewRadar1: TAction;
    N2: TMenuItem;
    TileWindow1: TMenuItem;
    Radar1: TMenuItem;
    ViewSpecial1: TAction;
    SpecialTiles1: TMenuItem;
    ViewTileInfo1: TAction;
    ViewWindows: TMenuItem;
    ileInfo1: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    FileImportTileset1: TMenuItem;
    N4: TMenuItem;
    FileCloseItem: TMenuItem;
    btnMapGrid: TToolButton;
    btnRadar: TToolButton;
    btnTileWindow: TToolButton;
    btnSpecials: TToolButton;
    btnInfo: TToolButton;
    ViewMapGrid: TAction;
    ViewZoomIn: TAction;
    ViewZoomOut: TAction;
    ViewZoomDef: TAction;
    MapTools: TToolBar;
    btnPen: TToolButton;
    btnSelect: TToolButton;
    btnErase: TToolButton;
    btnDropper: TToolButton;
    btnStamp: TToolButton;
    btnMagnify: TToolButton;
    btnSpace4: TToolButton;
    btnFillSel: TToolButton;
    btnFlipHori: TToolButton;
    btnFlipVert: TToolButton;
    btnSpace5: TToolButton;
    SetPen: TAction;
    setErase: TAction;
    setDropper: TAction;
    setMagnify: TAction;
    setStamp: TAction;
    setCircle: TAction;
    setFillCircle: TAction;
    setLine: TAction;
    setConLine: TAction;
    setSelect: TAction;
    setSquare: TAction;
    setFillSquare: TAction;
    selFill: TAction;
    selFlipHori: TAction;
    selFlipVert: TAction;
    btnLine: TToolButton;
    btnPolyLine: TToolButton;
    btnRect: TToolButton;
    btnCircle: TToolButton;
    OldTileWindow1: TMenuItem;
    ViewToggleSteveh: TAction;
    btnFillArea: TToolButton;
    setFill: TAction;
    MRU: TMenuFileHistory;
    btnSpace6: TToolButton;
    btnRotCCW: TToolButton;
    selRotCCW: TAction;
    btnRotCW: TToolButton;
    selRotCW: TAction;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure SendFeedback1Click(Sender: TObject);
    procedure SendFeedback2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HelpAboutExecute(Sender: TObject);
    procedure echSupportFAQ1Click(Sender: TObject);
    procedure FileSaveAs1Execute(Sender: TObject);
    procedure FileSave1Execute(Sender: TObject);
    procedure FileImport1Execute(Sender: TObject);
    procedure FileClose1Execute(Sender: TObject);
    procedure ViewZoom100Execute(Sender: TObject);
    procedure ViewZoomIncExecute(Sender: TObject);
    procedure ViewZoomDecExecute(Sender: TObject);
    procedure ViewToolBar1Execute(Sender: TObject);
    procedure ViewStatusBar1Execute(Sender: TObject);
    procedure MRUHistoryFileSelected(Sender: TObject; FileName: String);
    procedure ViewTileWindowExecute(Sender: TObject);
    procedure ViewRadar1Execute(Sender: TObject);
    procedure ViewSpecial1Execute(Sender: TObject);
    procedure ViewTileInfo1Execute(Sender: TObject);
    procedure ViewMapGridExecute(Sender: TObject);
    procedure ViewZoomInExecute(Sender: TObject);
    procedure ViewZoomOutExecute(Sender: TObject);
    procedure ViewZoomDefExecute(Sender: TObject);
    procedure SetTool(Sender: TObject);
    procedure ViewToggleStevehExecute(Sender: TObject);
    procedure selFillExecute(Sender: TObject);
    procedure selFlipVertExecute(Sender: TObject);
    procedure selFlipHoriExecute(Sender: TObject);
    procedure GuideandHelp1Click(Sender: TObject);
    procedure selRotCCWExecute(Sender: TObject);
    procedure selRotCWExecute(Sender: TObject);
  protected
    procedure WMDROPFILES (var Msg: TMessage); message WM_DROPFILES;
  private
    { Private declarations }
  public
    { Public declarations }
    Tool : Byte;
    hasCopy : boolean;
    clip : array of array of Byte;
    procedure CreateMDIChild(const Name: string);

  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}
{$R Cursor.res}

uses CHILDWIN, about, OPTIONS, TILE, RADAR, SPECIAL, TILESELECTED;

procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
  { create a new MDI child window }
  Child := TMDIChild.Create(Application);
  Child.Caption := ExtractFileName(name);
  if FileExists(Name) then Child.Loadmap(Name);
  if MDIChildCount = 1 then
  begin
    //SpecialBox.Show;
    TileSel.Show;
    TileWindow.Show;
    RadarBox.Show;
  end;
  FileSaveAs1.Enabled := True;
  FileImport1.Enabled := True;
  FileClose1.Enabled := True;
end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  CreateMDIChild(DEFAULT_NAME + IntToStr(MDIChildCount + 1));
end;

procedure TMainForm.FileOpen1Execute(Sender: TObject);
var
  i : integer;
  ext : String;
begin
  if OpenDialog.Execute then
  begin
    if MDIChildCount > 0 then
      for i := 0 to MDIChildCount-1 do
      begin
        if ((MDIChildren[i] as TMDIChild).getFileName() = OpenDialog.FileName) then
        begin
          MDIChildren[i].BringToFront;
          exit;
        end;
      end;

    ext := extractFileExt(OpenDialog.FileName);

    if ((AnsiUpperCase(ext) = '.LVL') or (AnsiUpperCase(ext) = '.BMP')) then
    begin
      CreateMDIChild(OpenDialog.FileName);
      MRU.AddHistoryFile(OpenDialog.FileName);
    end
    else
      MessageDlg('Can not handle files of that type.', mtError, [mbOK], 0);
  end;
end;


procedure TMainForm.FileExit1Execute(Sender: TObject);
var
 i : integer;
begin
  if mDIChildCount > 0 then
    for i := 0 to MDIChildCount -1 do
      MDIChildren[i].Close;
  Close;
end;

procedure TMainForm.SendFeedback1Click(Sender: TObject);
begin
  ShellExecute(Application.Handle, 'open', 'http://www.subspacehq.com/cle', '', '', SW_SHOW);

end;

procedure TMainForm.SendFeedback2Click(Sender: TObject);
begin
  ShellExecute(Application.Handle, 'open', 'mailto:hbk@ds98.net, cuervomuerte@hotmail.com', '', '', SW_SHOW);
end;


//makes sure all the options are set properly
procedure TMainForm.FormCreate(Sender: TObject);
begin
  SetWindowLong(ClientHandle, GWL_EXSTYLE, WS_EX_CLIENTEDGE);
  SetWindowPos(ClientHandle, HWND_BOTTOM, 0,0,0,0,SWP_NOCOPYBITS);

  //To which menuitem will we add the file history list?
  MRU.MenuForList := FileRecent;
  //How many files do we want in our list?
  MRU.FilesInList := 10;
  //Specify the file where the file history list will be maintained.
  //This history file is formatted like a Windows .ini file
  MRU.HistoryListFile := ExtractFilePath(Application.ExeName) + 'FileList.ini';
  //Fill the menu (value of the MenuForList property) with the
  //file history.  Only call this method one time, usually when
  //you start your application
  //REMEMBER TO ALWAYS CALL THIS METHOD WHEN YOU START YOUR APPLICATION!!
  MRU.FillMenuHistory;

  screen.cursors[16]:=LoadCursor(HInstance, 'PENCIL');
  screen.cursors[ERASE]:=loadcursor(HInstance,'ERASE');
  screen.cursors[STAMPER]:=loadcursor(HInstance,'STAMP');
  screen.cursors[DROPPER]:=loadcursor(HInstance,'DROPPER');
  screen.cursors[MAGNIFY]:=loadcursor(HInstance,'MAGNIFY');
  screen.cursors[SELECT]:=loadcursor(HInstance,'PLUS');
  screen.Cursors[AREAFILL] := loadcursor(HInstance,'FILL');

  tool := 0; //starts as pen
  setPen.Checked := true;
  DragAcceptFiles(MainForm.Handle, true);
end;

procedure TMainForm.HelpAboutExecute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.echSupportFAQ1Click(Sender: TObject);
begin
  ShellExecute(Application.Handle, 'open', 'http://www.subspacehq.com/cle/faq.shtml', '', '', SW_SHOW);
end;

procedure TMainForm.FileSaveAs1Execute(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    (activeMDIChild as TMDIChild).SaveMap(saveDialog.FileName);
    MRU.AddHistoryFile(saveDialog.FileName);
  end;
end;

procedure TMainForm.FileSave1Execute(Sender: TObject);
begin
  if (ActiveMDIChild as TMDIChild).getFileName = '' then
  begin
    if (ActiveMDIChild as TMDIChild).isModified then
      if SaveDialog.Execute then
        begin
         (activeMDIChild as TMDIChild).SaveMap(saveDialog.FileName);
         MRU.AddHistoryFile(saveDialog.FileName);
        end;
  end
  else
  begin
    (ActiveMDIChild as TMDIChild).SaveMap((ActiveMDIChild as TMDIChild).getFileName);
    MRU.AddHistoryFile((ActiveMDIChild as TMDIChild).getFileName);
  end;
end;

procedure TMainForm.FileImport1Execute(Sender: TObject);
var
  ext : string;
begin
  if OpenDialog.Execute then
  if FileExists(openDialog.FileName) then
  begin
    ext := extractFileExt(OpenDialog.FileName);
    if ((AnsiUpperCase(ext) = '.LVL') or (AnsiUpperCase(ext) = '.BMP')) then
      (ActiveMDIChild as TMDIChild).loadTiles(openDialog.FileName)
    else
      MessageDlg('Can not handle files of that type.', mtError, [mbOK], 0);
  end;
end;

procedure TMainForm.FileClose1Execute(Sender: TObject);
begin
  (ActiveMDIChild as TMDIChild).Close;
end;

procedure TMainForm.ViewZoom100Execute(Sender: TObject);
var
  x, y : word;
begin
  x := (ActiveMDIChild as TMDIChild).TopLeftX + ((ActiveMDIChild as TMDIChild).dispX shr 1);
  y := (ActiveMDIChild as TMDIChild).TopLeftY + ((ActiveMDIChild as TMDIChild).dispY shr 1);
  (ActiveMDIChild as TMDIChild).zoomSet(4,x,y);
end;

procedure TMainForm.ViewZoomIncExecute(Sender: TObject);
begin
  (ActiveMDIChild as TMDIChild).ZoomIn;
end;

procedure TMainForm.ViewZoomDecExecute(Sender: TObject);
begin
  (ActiveMDIChild as TMDIChild).ZoomOut;
end;

procedure TMainForm.ViewToolBar1Execute(Sender: TObject);
begin
  tools.Visible := not tools.Visible;
end;

procedure TMainForm.ViewStatusBar1Execute(Sender: TObject);
begin
  statusbar.Visible := not statusbar.Visible;
end;

procedure TMainForm.MRUHistoryFileSelected(Sender: TObject;
  FileName: String);
var
 i : integer;
begin
if FileExists(FileName) then
  begin
  if MDIChildCount > 0 then
    for i := 0 to MDIChildCount-1 do
    begin
      if ((MDIChildren[i] as TMDIChild).getFileName() = FileName) then
      begin
        MDIChildren[i].BringToFront;
        exit;
      end;
    end;

    CreateMDIChild(FileName);
    MRU.AddHistoryFile(FileName);
  end;
end;

procedure TMainForm.ViewTileWindowExecute(Sender: TObject);
begin
  if ViewTileWindow.Checked then
    TileWindow.Show
  else
    TileWindow.Hide;

end;

procedure TMainForm.ViewRadar1Execute(Sender: TObject);
begin
  if ViewRadar1.Checked then
    RadarBox.Show
  else
    RadarBox.Hide;
end;

procedure TMainForm.ViewSpecial1Execute(Sender: TObject);
begin
  if ViewSpecial1.Checked then
    SpecialBox.Show
  else
    SpecialBox.Hide;
end;

procedure TMainForm.ViewTileInfo1Execute(Sender: TObject);
begin
  if ViewTileInfo1.Checked then
    TileSel.Show
  else
    TileSel.Hide;
end;

procedure TMainForm.ViewMapGridExecute(Sender: TObject);
begin
  if MDIChildCount > 0 then
  begin
    (ActiveMDIChild as TMDIChild).mapGrid := ViewMapGrid.Checked;
    (ActiveMDIChild as TMDIChild).DrawMap;
  end;

end;

procedure TMainForm.ViewZoomInExecute(Sender: TObject);
begin
    (ActiveMDIChild as TMDIChild).zoomIn;
end;

procedure TMainForm.ViewZoomOutExecute(Sender: TObject);
begin
  if MDIChildCount > 0 then
    (ActiveMDIChild as TMDIChild).zoomOut;
end;

procedure TMainForm.ViewZoomDefExecute(Sender: TObject);
begin
  if MDIChildCount > 0 then
    (ActiveMDIChild as TMDIChild).zoomSet(4,0,0);
end;
  {PEN = 0;         //pen
  ERASE = 1;       //erasor
  SELECT = 2;      //marquee
  DROPPER = 3;     //eye dropper
  STAMPER = 4;     //stamper
  MAGNIFY = 5;     //maginifier
  FILL = 6;        //filler
  FLIPHORI = 7;    //flip horizontal
  FLIPVERT = 8;    //Flip vertical
  LINE = 9;        //Line
  POLYLINE = 10;   //connected line
  RECT = 11;       //rectangle/square
  RECTFILL = 12;   //filled
  CIRCLE = 13;     //ellipse/circle
  CIRCLEFILL = 14; //filled }
procedure TMainForm.SetTool(Sender: TObject);
var
 i :integer integer;
begin
  if Sender = setPen then tool := PEN
  else if Sender = setSelect then tool := SELECT
  else if Sender = setErase then tool := ERASE
  else if Sender = setDropper then tool := DROPPER
  else if Sender = setStamp then tool := STAMPER
  else if Sender = setMagnify then tool := MAGNIFY
  else if Sender = setLine then tool := LINE
  else if Sender = setConLine then tool := POLYLINE
  else if Sender = setSquare then tool := RECT
  else if Sender = setFillSquare then tool := RECTFILL
  else if Sender = setCircle then tool := CIRCLE
  else if Sender = setfillCircle then tool := CIRCLEFILL
  else if Sender = setFill then tool := AREAFILL;

  //things needed to change when a tool changes
  if MDIChildCount > 0 then
  for i := 0 to MDIChildCount -1 do
  begin
    (mdiChildren[i] as TMDIChild).isDrawing := false;
    if tool <> SELECT then
      (mdiChildren[i] as TMDIChild).selDraw := false;
      (mdiChildren[i] as TMDIChild).DrawMap;
      (mdiChildren[i] as TMDIChild).actEditClear.Enabled := false;
      (mdiChildren[i] as TMDIChild).actEditCut.Enabled := false;
      (mdiChildren[i] as TMDIChild).actEditCopy.Enabled := false;
    case tool of
      PEN : (mdiChildren[i] as TMDIChild).mapDraw.Cursor := 16;//can't use 0
      ERASE : (mdiChildren[i] as TMDIChild).mapDraw.Cursor := ERASE;
      DROPPER : (mdiChildren[i] as TMDIChild).mapDraw.Cursor :=  DROPPER;
      STAMPER : (mdiChildren[i] as TMDIChild).mapDraw.Cursor := STAMPER;
      MAGNIFY : (mdiChildren[i] as TMDIChild).mapDraw.Cursor := MAGNIFY;
      SELECT,LINE..CIRCLEFILL : (mdiChildren[i] as TMDIChild).mapDraw.Cursor := SELECT;
      AREAFILL : (mdiChildren[i] as TMDIChild).mapDraw.Cursor := AREAFILL;
    end;
  end;

  {case tool of
 {  // PEN : cursor

  end;}
  if tool = STAMPER then
    SpecialBox.Visible := true;


  if tool <> SELECT then
  begin
    selFill.Enabled := false;
    selFlipHori.Enabled := false;
    selFlipVert.Enabled := false;
    selRotCW.Enabled := false;
    selRotCCW.Enabled := false;
  end;

  (Sender as TAction).Checked := false;
  (Sender as TAction).Checked := true;
end;

procedure TMainForm.ViewToggleStevehExecute(Sender: TObject);
begin
  TileWindow.toggleSteveh(ViewToggleSteveh.Checked);
  TileWindow.Invalidate;
end;

procedure TMainForm.selFillExecute(Sender: TObject);
begin
  if MDIChildcount > 0 then
    (activeMDIChild as tmdiChild).fill;
end;

procedure TMainForm.selFlipVertExecute(Sender: TObject);
begin
  if MDIChildcount > 0 then
    (activeMDIChild as tmdiChild).flipVert;
end;

procedure TMainForm.selFlipHoriExecute(Sender: TObject);
begin
  if MDIChildcount > 0 then
    (activeMDIChild as tmdiChild).flipHori;
end;

procedure TMainForm.WMDROPFILES (var Msg: TMessage);
var
 i, j,
 amount,
 size: integer;
 Filename: PChar;
 S: string;
 begin
 inherited;
 Filename := '';
 Amount := DragQueryFile(Msg.WParam, $FFFFFFFF, Filename, 255);
 for i := 0 to (Amount - 1) do
 begin
  size := DragQueryFile(Msg.WParam, i , nil, 0) + 1;
  Filename:= StrAlloc(size);
  DragQueryFile(Msg.WParam,i , Filename, size);
  s := Extractfileext(Filename);
 if ((AnsiLowerCase(s) <> '.lvl') and (AnsiLowerCase(s) <> '.bmp')) then
  exit
 else
 begin

 if FileExists(FileName) then
  begin
  if MDIChildCount > 0 then
    for j := 0 to MDIChildCount-1 do
    begin
      if ((MDIChildren[j] as TMDIChild).getFileName() = FileName) then
      begin
        MDIChildren[j].BringToFront;
        exit;
      end;
    end;

    CreateMDIChild(FileName);
    MRU.AddHistoryFile(FileName);
  end;

 end;
  StrDispose(Filename);
 end;
 DragFinish(Msg.WParam);
end;

procedure TMainForm.GuideandHelp1Click(Sender: TObject);
begin
  Application.HelpFile := ExtractFilePath(Application.ExeName)+'cle.hlp';
  Application.HelpCommand(HELP_CONTENTS, 0);

end;

procedure TMainForm.selRotCCWExecute(Sender: TObject);
begin
  if MDIChildcount > 0 then
    (activeMDIChild as tmdiChild).rotateCCW;

end;

procedure TMainForm.selRotCWExecute(Sender: TObject);
begin
  if MDIChildcount > 0 then
    (activeMDIChild as tmdiChild).rotateCW;

end;

end.
